/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights 
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:  
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "WSIF" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written 
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation and was
 * originally based on software copyright (c) 2001, 2002, International
 * Business Machines, Inc., http://www.apache.org.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package clients.zipcode;

import java.net.*;
import java.util.*;
import org.w3c.dom.*;
import org.apache.soap.*;
import org.apache.soap.encoding.*;
import org.apache.soap.encoding.soapenc.*;
import org.apache.soap.rpc.*;
import org.apache.soap.util.xml.*;
import org.apache.soap.messaging.*;

public class zipcoderesolverProxy
{
  private Call call = new Call();
  private URL url = null;
  private String stringURL = "http://webservices.eraserver.net/zipcoderesolver/zipcoderesolver.asmx";
  private SOAPMappingRegistry smr = call.getSOAPMappingRegistry();

  public zipcoderesolverProxy()
  {
  }

  public synchronized void setEndPoint(URL url)
  {
    this.url = url;
  }

  public synchronized URL getEndPoint() throws MalformedURLException
  {
    return getURL();
  }

  private URL getURL() throws MalformedURLException
  {
    if (url == null && stringURL != null && stringURL.length() > 0)
    {
      url = new URL(stringURL);
    }
    return url;
  }




  public synchronized org.w3c.dom.Element ShortZipCode_(org.w3c.dom.Element parameters) throws Exception
  {
    String targetObjectURI = "";
    String SOAPActionURI = "http://webservices.eraserver.net/ShortZipCode";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via zipcoderesolverProxy.setEndPoint(URL).");
    }

    // create message envelope and body
    Envelope msgEnv = new Envelope();
    Body msgBody = new Body();
    Vector vect = new Vector();

    vect.add(parameters);
    msgBody.setBodyEntries(vect);
    msgEnv.setBody(msgBody);

    // create and send message
    Message msg = new Message();
    msg.send(getURL(),SOAPActionURI, msgEnv);

    // receive response envelope
    Envelope env = msg.receiveEnvelope();
    Body retbody = env.getBody();
    java.util.Vector v = retbody.getBodyEntries();

    return (Element)v.firstElement();
    
  }

  public synchronized ShortZipCodeResponse_ElementContentType ShortZipCode(ShortZipCode_ElementContentType parameters) throws Exception
  {
    parameters.changeLocalName("ShortZipCode");
    parameters.changeNamespaceURI("http://webservices.eraserver.net/");
    org.w3c.dom.Element parameters_ = parameters.createElement();

    // delegate to method ShortZipCode_
    org.w3c.dom.Element result_ = ShortZipCode_(parameters_);

    // convert result_ from an org.w3c.dom.Element to ShortZipCodeResponse_ElementContentType
    ShortZipCodeResponse_ElementContentType aShortZipCodeResponse_ElementContentType = new ShortZipCodeResponse_ElementContentType();
    aShortZipCodeResponse_ElementContentType.populateFrom(result_);

    return aShortZipCodeResponse_ElementContentType;
  }











}
